using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;
using System;
using System.Collections.Generic;
using System.Threading;

namespace Hiko
{
    public class Hiko : PhysicsGame

    {
        PhysicsObject pelaaja;
        GameObject tahtain;
        Image taustakuva = LoadImage("Testitaustakuva");
        public override void Begin()
        {
            // Kirjoita ohjelmakoodisi tähän

            Level.CreateBorders();
            Camera.ZoomToLevel();
            Level.Background.Image = taustakuva;
            LuoPelaaja();
            Gravity = new Vector(0.0, -981.0);
            LuoOhjaimet();
            LuoTahtain();
            LuoMaavihu();
            PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
        }
        PhysicsObject LuoPelaaja()
        {
            pelaaja = new PhysicsObject(20, 40);
            pelaaja.Shape = Shape.Circle;
            pelaaja.Color = Color.Blue;
            pelaaja.Image = LoadImage("pääjehu2");
            pelaaja.CanRotate = false;
            pelaaja.AddCollisionIgnoreGroup(1);
            Add(pelaaja);
            return pelaaja;
        }
        PhysicsObject LuoMaavihu()
        {
            PhysicsObject maavihu = new PhysicsObject(50, 50);
            maavihu.Shape = Shape.Circle;
            maavihu.Color = Color.Blue;
            maavihu.Image = LoadImage("örkki");
            Add(maavihu);
            return maavihu;
        }
        GameObject LuoTahtain()
        {
            tahtain = new GameObject(30.0, 30.0, Shape.Circle);
            tahtain.Image = LoadImage("tähtäinristikko");
            Add(tahtain);
            return tahtain;
        }
        public void LuoOhjaimet()
        {
            Keyboard.Listen(Key.Left, ButtonState.Down, LiikutaPelaajaa, null, new Vector(-1000, 0));
            Keyboard.Listen(Key.Right, ButtonState.Down, LiikutaPelaajaa, null, new Vector(1000, 0));
            Keyboard.Listen(Key.Up, ButtonState.Down, LiikutaPelaajaa, null, new Vector(0, 1000));
            Keyboard.Listen(Key.Down, ButtonState.Down, LiikutaPelaajaa, null, new Vector(0, -1000));

            Mouse.IsCursorVisible = true;
            Mouse.ListenMovement(0.1, KuunteleLiiketta, null);

            Mouse.Listen(MouseButton.Left, ButtonState.Pressed, Ammu, null);

        }
        void LiikutaPelaajaa(Vector vektori)
        {
            pelaaja.Push(vektori);
        }
        void KuunteleLiiketta()
        {
            tahtain.X = Mouse.PositionOnWorld.X;
            tahtain.Y = Mouse.PositionOnWorld.Y;

        }
        void Ammu()
        {
            PhysicsObject luoti = new PhysicsObject(20, 20);
            luoti.Shape = Shape.Circle;
            luoti.Color = Color.Yellow;
            luoti.X = pelaaja.X;
            luoti.Y = pelaaja.Y;
            luoti.IgnoresGravity = true;
            luoti.IgnoresCollisionWith(pelaaja);
            luoti.AddCollisionIgnoreGroup(1);
            luoti.LifetimeLeft = TimeSpan.FromSeconds(0.3);
            luoti.Image = LoadImage("luoti");
            Add(luoti);

            //luoti.Hit(new Vector(pelaaja.RelativePosition.X - Mouse.PositionOnScreen.X, pelaaja.RelativePosition.Y - Mouse.PositionOnScreen.Y));
            Vector suunta = new Vector((pelaaja.RelativePosition.X - Mouse.PositionOnScreen.X) * -1, (pelaaja.RelativePosition.Y - Mouse.PositionOnScreen.Y) * -1);
            Angle a = suunta.Angle;
            
            luoti.Hit(Vector.FromLengthAndAngle(200, a));
            
        }

    }
}